import { Context, Signer, TransactionBuilderGroup } from '@metaplex-foundation/umi';
import { RuleSetRevision } from './revisions';
export declare const PUFF_CHUNK_SIZE = 10000;
export type CreateOrUpdateWithBufferV1Input = {
    /** Payer and creator of the RuleSet */
    payer?: Signer;
    /** The name of the RuleSet account. */
    ruleSetName: string;
    /** The new revision to add to the RuleSet account. */
    ruleSetRevision: RuleSetRevision;
    /**
     * The size of each chunk to write to the buffer.
     * @default `900`
     */
    chunkSize?: number;
};
export declare const createOrUpdateWithBufferV1: (context: Pick<Context, 'eddsa' | 'programs' | 'serializer' | 'payer' | 'transactions'>, input: CreateOrUpdateWithBufferV1Input) => TransactionBuilderGroup;
