"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateV1 = exports.getValidateV1InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getValidateV1InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['validateV1Discriminator', s.u8()],
        ['operation', s.string()],
        ['payload', (0, types_1.getPayloadSerializer)(context)],
        ['updateRuleState', s.bool()],
        ['ruleSetRevision', s.option(s.u64())],
    ], { description: 'ValidateV1InstructionData' }), (value) => ({ ...value, discriminator: 1, validateV1Discriminator: 0 }));
}
exports.getValidateV1InstructionDataSerializer = getValidateV1InstructionDataSerializer;
// Instruction.
function validateV1(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenAuthRules', 'auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'ruleAuthority', input.ruleAuthority ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'ruleSetStatePda', input.ruleSetStatePda ?? programId);
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Rule Set Pda.
    keys.push({
        pubkey: resolvedAccounts.ruleSetPda,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ruleSetPda, false),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Payer.
    if ((0, umi_1.isSigner)(resolvedAccounts.payer)) {
        signers.push(resolvedAccounts.payer);
    }
    keys.push({
        pubkey: (0, umi_1.publicKey)(resolvedAccounts.payer),
        isSigner: (0, umi_1.isSigner)(resolvedAccounts.payer),
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Rule Authority.
    if ((0, umi_1.isSigner)(resolvedAccounts.ruleAuthority)) {
        signers.push(resolvedAccounts.ruleAuthority);
    }
    keys.push({
        pubkey: (0, umi_1.publicKey)(resolvedAccounts.ruleAuthority),
        isSigner: (0, umi_1.isSigner)(resolvedAccounts.ruleAuthority),
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ruleAuthority, false),
    });
    // Rule Set State Pda.
    keys.push({
        pubkey: resolvedAccounts.ruleSetStatePda,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ruleSetStatePda, true),
    });
    // Data.
    const data = getValidateV1InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.validateV1 = validateV1;
//# sourceMappingURL=validateV1.js.map