"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRuleSetRevisionInputSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const revisions_1 = require("../revisions");
const getRuleSetRevisionInputSerializer = (context) => {
    const ruleSetSerializer = (0, revisions_1.getRuleSetRevisionSerializer)(context);
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.bytes({ size: s.u32() }), (revision) => {
        if ((0, umi_1.isNone)(revision))
            return new Uint8Array();
        return ruleSetSerializer.serialize(revision.value);
    }, (bytes) => {
        if (bytes.length === 0)
            return (0, umi_1.none)();
        const [ruleSet] = ruleSetSerializer.deserialize(bytes, 4);
        return (0, umi_1.some)(ruleSet);
    });
};
exports.getRuleSetRevisionInputSerializer = getRuleSetRevisionInputSerializer;
//# sourceMappingURL=ruleSetRevisionInput.js.map