import { Context, Serializer } from '@metaplex-foundation/umi';
import { RuleSetRevisionV1 } from './v1';
import { RuleSetRevisionV2 } from './v2';
export type RuleSetRevision = RuleSetRevisionV1 | RuleSetRevisionV2;
export declare const getRuleSetRevisionSerializer: (context: Pick<Context, 'serializer'>) => Serializer<RuleSetRevision>;
export declare const getRuleSetRevisionSerializerFromVersion: <T extends RuleSetRevision>(context: Pick<Context, 'serializer'>, version: T["libVersion"]) => Serializer<T, T>;
export declare const isRuleSetV1: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV1;
export declare const isRuleSetV2: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV2;
export declare const getRuleSetRevisionFromJson: (json: string) => RuleSetRevision;
export declare const getLatestRuleSetRevision: (context: Pick<Context, 'serializer'>, buffer: Uint8Array) => RuleSetRevision;
