import { Context, PublicKeyBase58, PublicKeyInput, Serializer } from '@metaplex-foundation/umi';
import type { RuleV1 } from '../v1';
import { RuleV2 } from './rule';
export type AdditionalSignerRuleV2 = {
    type: 'AdditionalSigner';
    publicKey: PublicKeyBase58;
};
export declare const additionalSignerV2: (publicKey: PublicKeyInput) => AdditionalSignerRuleV2;
export declare const getAdditionalSignerRuleV2Serializer: (context: Pick<Context, 'serializer'>) => Serializer<AdditionalSignerRuleV2>;
export declare const isAdditionalSignerRuleV2: (rule: RuleV1 | RuleV2) => rule is AdditionalSignerRuleV2;
