"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAdditionalSignerRuleV2 = exports.getAdditionalSignerRuleV2Serializer = exports.additionalSignerV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const additionalSignerV2 = (publicKey) => ({
    type: 'AdditionalSigner',
    publicKey: (0, umi_1.base58PublicKey)(publicKey),
});
exports.additionalSignerV2 = additionalSignerV2;
const getAdditionalSignerRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.AdditionalSigner, s.struct([['publicKey', s.string({ encoding: umi_1.base58, size: 32 })]]));
};
exports.getAdditionalSignerRuleV2Serializer = getAdditionalSignerRuleV2Serializer;
const isAdditionalSignerRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'AdditionalSigner';
exports.isAdditionalSignerRuleV2 = isAdditionalSignerRuleV2;
//# sourceMappingURL=additionalSigner.js.map