import { Context, Serializer } from '@metaplex-foundation/umi';
import { AmountOperator, AmountOperatorString } from '../shared';
import type { RuleV1 } from '../v1';
import { RuleV2 } from './rule';
export type AmountRuleV2 = {
    type: 'Amount';
    field: string;
    operator: AmountOperatorString;
    amount: number;
};
export declare const amountV2: (field: string, operator: AmountOperator | AmountOperatorString, amount: number) => AmountRuleV2;
export declare const getAmountRuleV2Serializer: (context: Pick<Context, 'serializer'>) => Serializer<AmountRuleV2>;
export declare const isAmountRuleV2: (rule: RuleV1 | RuleV2) => rule is AmountRuleV2;
