"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAmountRuleV2 = exports.getAmountRuleV2Serializer = exports.amountV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const shared_1 = require("../shared");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const amountV2 = (field, operator, amount) => ({
    type: 'Amount',
    field,
    operator: (0, shared_1.toAmountOperatorString)(operator),
    amount,
});
exports.amountV2 = amountV2;
const getAmountRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.Amount, s.struct([
        [
            'amount',
            (0, umi_1.mapSerializer)(s.u64(), (v) => v, (v) => Number(v)),
        ],
        [
            'operator',
            (0, umi_1.mapSerializer)(s.u64(), (v) => (0, shared_1.toAmountOperator)(v), (v) => (0, shared_1.toAmountOperatorString)(Number(v))),
        ],
        ['field', s.string({ size: 32 })],
    ]));
};
exports.getAmountRuleV2Serializer = getAmountRuleV2Serializer;
const isAmountRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'Amount';
exports.isAmountRuleV2 = isAmountRuleV2;
//# sourceMappingURL=amount.js.map