"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAnyRuleV2 = exports.getAnyRuleV2Serializer = exports.anyV2 = void 0;
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const anyV2 = (rules) => ({ type: 'Any', rules });
exports.anyV2 = anyV2;
const getAnyRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.Any, s.struct([
        ['rules', s.array((0, rule_1.getRuleV2Serializer)(context), { size: s.u64() })],
    ]));
};
exports.getAnyRuleV2Serializer = getAnyRuleV2Serializer;
const isAnyRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'Any';
exports.isAnyRuleV2 = isAnyRuleV2;
//# sourceMappingURL=any.js.map