import { Context, PublicKeyBase58, PublicKeyInput, Serializer } from '@metaplex-foundation/umi';
import type { RuleV1 } from '../v1';
import { RuleV2 } from './rule';
export type PdaMatchRuleV2 = {
    type: 'PdaMatch';
    pdaField: string;
    program: PublicKeyBase58;
    seedsField: string;
};
export declare const pdaMatchV2: (pdaField: string, program: PublicKeyInput, seedsField: string) => PdaMatchRuleV2;
export declare const getPdaMatchRuleV2Serializer: (context: Pick<Context, 'serializer'>) => Serializer<PdaMatchRuleV2>;
export declare const isPdaMatchRuleV2: (rule: RuleV1 | RuleV2) => rule is PdaMatchRuleV2;
