"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPdaMatchRuleV2 = exports.getPdaMatchRuleV2Serializer = exports.pdaMatchV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pdaMatchV2 = (pdaField, program, seedsField) => ({
    type: 'PdaMatch',
    pdaField,
    program: (0, umi_1.base58PublicKey)(program),
    seedsField,
});
exports.pdaMatchV2 = pdaMatchV2;
const getPdaMatchRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.PdaMatch, s.struct([
        ['program', s.string({ encoding: umi_1.base58, size: 32 })],
        ['pdaField', s.string({ size: 32 })],
        ['seedsField', s.string({ size: 32 })],
    ]));
};
exports.getPdaMatchRuleV2Serializer = getPdaMatchRuleV2Serializer;
const isPdaMatchRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'PdaMatch';
exports.isPdaMatchRuleV2 = isPdaMatchRuleV2;
//# sourceMappingURL=pdaMatch.js.map