import { Context, PublicKeyBase58, PublicKeyInput, Serializer } from '@metaplex-foundation/umi';
import type { RuleV1 } from '../v1';
import { RuleV2 } from './rule';
export type ProgramOwnedRuleV2 = {
    type: 'ProgramOwned';
    field: string;
    program: PublicKeyBase58;
};
export declare const programOwnedV2: (field: string, program: PublicKeyInput) => ProgramOwnedRuleV2;
export declare const getProgramOwnedRuleV2Serializer: (context: Pick<Context, 'serializer'>) => Serializer<ProgramOwnedRuleV2>;
export declare const isProgramOwnedRuleV2: (rule: RuleV1 | RuleV2) => rule is ProgramOwnedRuleV2;
