"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isProgramOwnedRuleV2 = exports.getProgramOwnedRuleV2Serializer = exports.programOwnedV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const programOwnedV2 = (field, program) => ({
    type: 'ProgramOwned',
    program: (0, umi_1.base58PublicKey)(program),
    field,
});
exports.programOwnedV2 = programOwnedV2;
const getProgramOwnedRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.ProgramOwned, s.struct([
        ['program', s.string({ encoding: umi_1.base58, size: 32 })],
        ['field', s.string({ size: 32 })],
    ]));
};
exports.getProgramOwnedRuleV2Serializer = getProgramOwnedRuleV2Serializer;
const isProgramOwnedRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'ProgramOwned';
exports.isProgramOwnedRuleV2 = isProgramOwnedRuleV2;
//# sourceMappingURL=programOwned.js.map