"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isProgramOwnedListRuleV2 = exports.getProgramOwnedListRuleV2Serializer = exports.programOwnedListV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const programOwnedListV2 = (field, programs) => ({
    type: 'ProgramOwnedList',
    field,
    programs: programs.map(umi_1.base58PublicKey),
});
exports.programOwnedListV2 = programOwnedListV2;
const getProgramOwnedListRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.ProgramOwnedList, s.struct([
        ['field', s.string({ size: 32 })],
        [
            'programs',
            s.array(s.string({ encoding: umi_1.base58, size: 32 }), {
                size: 'remainder', // TODO: Ensure this works.
            }),
        ],
    ]));
};
exports.getProgramOwnedListRuleV2Serializer = getProgramOwnedListRuleV2Serializer;
const isProgramOwnedListRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'ProgramOwnedList';
exports.isProgramOwnedListRuleV2 = isProgramOwnedListRuleV2;
//# sourceMappingURL=programOwnedList.js.map