"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isProgramOwnedTreeRuleV2 = exports.getProgramOwnedTreeRuleV2Serializer = exports.programOwnedTreeV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const programOwnedTreeV2 = (pubkeyField, proofField, root) => ({
    type: 'ProgramOwnedTree',
    pubkeyField,
    proofField,
    root: [...root],
});
exports.programOwnedTreeV2 = programOwnedTreeV2;
const getProgramOwnedTreeRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.ProgramOwnedTree, s.struct([
        ['pubkeyField', s.string({ size: 32 })],
        ['proofField', s.string({ size: 32 })],
        [
            'root',
            (0, umi_1.mapSerializer)(s.bytes({ size: 32 }), (v) => new Uint8Array(v), (v) => [...v]),
        ],
    ]));
};
exports.getProgramOwnedTreeRuleV2Serializer = getProgramOwnedTreeRuleV2Serializer;
const isProgramOwnedTreeRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'ProgramOwnedTree';
exports.isProgramOwnedTreeRuleV2 = isProgramOwnedTreeRuleV2;
//# sourceMappingURL=programOwnedTree.js.map