"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPubkeyListMatchRuleV2 = exports.getPubkeyListMatchRuleV2Serializer = exports.pubkeyListMatchV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pubkeyListMatchV2 = (field, publicKeys) => ({
    type: 'PubkeyListMatch',
    field,
    publicKeys: publicKeys.map(umi_1.base58PublicKey),
});
exports.pubkeyListMatchV2 = pubkeyListMatchV2;
const getPubkeyListMatchRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.PubkeyListMatch, s.struct([
        ['field', s.string({ size: 32 })],
        [
            'publicKeys',
            s.array(s.string({ encoding: umi_1.base58, size: 32 }), {
                size: 'remainder', // TODO: Ensure this works.
            }),
        ],
    ]));
};
exports.getPubkeyListMatchRuleV2Serializer = getPubkeyListMatchRuleV2Serializer;
const isPubkeyListMatchRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'PubkeyListMatch';
exports.isPubkeyListMatchRuleV2 = isPubkeyListMatchRuleV2;
//# sourceMappingURL=pubkeyListMatch.js.map