"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPubkeyMatchRuleV2 = exports.getPubkeyMatchRuleV2Serializer = exports.pubkeyMatchV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pubkeyMatchV2 = (field, publicKey) => ({
    type: 'PubkeyMatch',
    publicKey: (0, umi_1.base58PublicKey)(publicKey),
    field,
});
exports.pubkeyMatchV2 = pubkeyMatchV2;
const getPubkeyMatchRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.PubkeyMatch, s.struct([
        ['publicKey', s.string({ encoding: umi_1.base58, size: 32 })],
        ['field', s.string({ size: 32 })],
    ]));
};
exports.getPubkeyMatchRuleV2Serializer = getPubkeyMatchRuleV2Serializer;
const isPubkeyMatchRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'PubkeyMatch';
exports.isPubkeyMatchRuleV2 = isPubkeyMatchRuleV2;
//# sourceMappingURL=pubkeyMatch.js.map