import { Context, Serializer } from '@metaplex-foundation/umi';
import type { RuleV1 } from '../v1';
import { AdditionalSignerRuleV2 } from './additionalSigner';
import { AllRuleV2 } from './all';
import { AmountRuleV2 } from './amount';
import { AnyRuleV2 } from './any';
import { NamespaceRuleV2 } from './namespace';
import { NotRuleV2 } from './not';
import { PassRuleV2 } from './pass';
import { PdaMatchRuleV2 } from './pdaMatch';
import { ProgramOwnedRuleV2 } from './programOwned';
import { ProgramOwnedListRuleV2 } from './programOwnedList';
import { ProgramOwnedTreeRuleV2 } from './programOwnedTree';
import { PubkeyListMatchRuleV2 } from './pubkeyListMatch';
import { PubkeyMatchRuleV2 } from './pubkeyMatch';
import { PubkeyTreeMatchRuleV2 } from './pubkeyTreeMatch';
export type RuleV2 = AdditionalSignerRuleV2 | AllRuleV2 | AmountRuleV2 | AnyRuleV2 | NamespaceRuleV2 | NotRuleV2 | PassRuleV2 | PdaMatchRuleV2 | ProgramOwnedRuleV2 | ProgramOwnedListRuleV2 | ProgramOwnedTreeRuleV2 | PubkeyListMatchRuleV2 | PubkeyMatchRuleV2 | PubkeyTreeMatchRuleV2;
export declare const getRuleV2Serializer: (context: Pick<Context, 'serializer'>) => Serializer<RuleV2>;
export declare const getRuleV2SerializerFromType: <T extends RuleV2>(context: Pick<Context, 'serializer'>, type: T["type"]) => Serializer<T, T>;
export declare const isRuleV2: (rule: RuleV1 | RuleV2) => rule is RuleV2;
